/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-30 16:47
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const int MAXN = 2e5 + 5;
ll N;


// T, NEUTRAL, d() and m() depend on f
typedef int T;
const T NEUTRAL = -1;
T m(T l, T r){ return max(l, r); }
struct interval_tree {
  int LG, N;
  vector<T> t;
  interval_tree(vector<int> &a){
    LG = bit_width(size(a) - 1), N = 1 << LG;
    t.assign(2 << LG, NEUTRAL);
    for(int i = 0; i < N; i++)
      t[N - 1 + i] =
        i < ssize(a) ? a[i] : NEUTRAL;
    for(int i = N - 2; i >= 0; i--)
      t[i] = m(t[lc(i)], t[rc(i)]);
  }
  T get(int l, int r){
    l += N - 1, r += N - 1;
    T res = NEUTRAL;
    while(l <= r && (l != 0 || r != 0)){
      if(!(l & 1)) res = m(res, t[l++]);
      if(r & 1) res = m(res, t[r--]);
      l = pa(l), r = pa(r);
    }
    return res;
  }
  void set(int p, T val){
    p += N - 1, t[p] = val;
    while(p > 0){ // <=> while p != pa(p)
      p = pa(p);
      t[p] = m(t[lc(p)], t[rc(p)]);
    }
  }
  int pa(int x){ return (x - 1) / 2; }
  int lc(int x){ return 2 * x + 1; }
  int rc(int x){ return 2 * x + 2; }
  int getmuls(int x){
      int c = 0;
      for(int i = 0; i < N; i++){
          if(t[N - 1 + i] == x)
              c++;
      }
      return c;
  }
};


void solve(){
    // Code goes here ...
    cin >> N;

    map<int,int> m;
    int curk, curv;
    /* R(i, N){ */
    /*     cin >> curk; */
    /*     auto it = m.upper_bound(curk); */
    /*     if(it == end(m)) */
    /*         m.emplace(curk, 0); */
    /*     else{ */
    /*         auto [k, v] = *it; */
    /*         m.emplace(curk, v + 1); */
    /*     } */
    /* } */


    vector<int> tmp(N + 9, -1);
    interval_tree tree(tmp);
    cin >> curk;
    int c = 0;
    int lastk = lastk;
    R(i, N - 1){
        cin >> curk;
        if(lastk > curk) c++;
        /* curv = tree.get(curk + 1, N); */
        /* tree.set(curk, curv+1); */
        /* cerr << curk << " : " << curv + 1 << endl; */
        lastk = curk;
    }
    cerr << "C " << c << endl;

    int res = tree.get(0, N);
    /* cerr << " ===== " << endl; */
    /* for(auto [k, v] : m){ */
    /*     ckmax(res, v); */
    /*     cerr << k << " : " << v << endl; */
    /* } */
    res += tree.getmuls(res) - 1;
    cout << res << endl;

}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    return 0;
}
        
